using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Runtime.InteropServices;
using System.Reflection;
using System.IO;

namespace MyNewService
{
	public class Service1 : System.ServiceProcess.ServiceBase
	{
        public static void StrToLog(string str)
        {
            //String.Format("{0:x}", handle);
            using (StreamWriter sw = File.AppendText("C:\\MailLog.txt"))
            {
                sw.WriteLine(DateTime.Now.Hour.ToString() +":"+
                    DateTime.Now.Minute.ToString() +":"+ 
                    DateTime.Now.Second.ToString() +":"+ 
                    DateTime.Now.Millisecond.ToString() +" -> "+str);
            }
        }
        private AddinExpress.Outlook.SecurityManager securityManager1;
        private System.Timers.Timer timer1;
        private System.Diagnostics.EventLog eventLog1;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Service1()
		{
			// This call is required by the Windows.Forms Component Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitComponent call
			if(!System.Diagnostics.EventLog.SourceExists("DoDyLogSourse"))
			{	
				System.Diagnostics.EventLog.CreateEventSource("DoDyLogSourse","DoDyLog");
			}

				eventLog1.Source = "DoDyLogSourse";
				eventLog1.Log ="DoDyLog";
			
		}

		// The main entry point for the process
           
		static void Main()
		{
			System.ServiceProcess.ServiceBase[] ServicesToRun;
	
			// More than one user Service may run within the same process. To add
			// another service to this process, change the following line to
			// create a second service object. For example,
			//
			//   ServicesToRun = New System.ServiceProcess.ServiceBase[] {new Service1(), new MySecondUserService()};
			//
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new MyNewService.Service1()};

			System.ServiceProcess.ServiceBase.Run(ServicesToRun);	
		}

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.securityManager1 = new AddinExpress.Outlook.SecurityManager();
            this.timer1 = new System.Timers.Timer();
            this.eventLog1 = new System.Diagnostics.EventLog();
            ((System.ComponentModel.ISupportInitialize)(this.timer1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.eventLog1)).BeginInit();
            // 
            // timer1
            // 
            this.timer1.Enabled = true;
            this.timer1.Interval = 2000;
            this.timer1.Elapsed += new System.Timers.ElapsedEventHandler(this.timer1_Elapsed);
            // 
            // Service1
            // 
            this.ServiceName = "MyNewService";
            ((System.ComponentModel.ISupportInitialize)(this.timer1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.eventLog1)).EndInit();

        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Set things in motion so your service can do its work.
		/// </summary>
		protected override void OnStart(string[] args)
		{
			// TODO: Add code here to start your service.

            StrToLog("my service started");            
		}
 
		/// <summary>
		/// Stop this service.
		/// </summary>
		protected override void OnStop()
		{
			// TODO: Add code here to perform any tear-down necessary to stop your service.
			
            StrToLog("my service stoped");            
		}
		protected override void OnContinue()
		{

            StrToLog("my service is continuing in working");
		}

        private string[] DoCDO()
        {
            object mapiSession = null, objItem = null, inbox = null,
                messages = null, sender = null;
            string[] lines = new string[4];
            
            Type tpMapi = Type.GetTypeFromProgID("MAPI.Session", false);
            if (tpMapi != null)
            {            
            
                securityManager1.DisableCDOWarnings = true;
                try
                {
                    mapiSession = Activator.CreateInstance(tpMapi);
                    if (mapiSession != null)
                    {
                        try
                        {
            
                            mapiSession.GetType().InvokeMember("Logon", BindingFlags.InvokeMethod, null, mapiSession, 
                                new object[]{"Outlook", Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing});                            
                            inbox = mapiSession.GetType().InvokeMember("Inbox", BindingFlags.GetProperty, null, mapiSession, null);                            
                            messages = inbox.GetType().InvokeMember("Messages", BindingFlags.GetProperty, null, inbox, null);                            
                            objItem = messages.GetType().InvokeMember("GetFirst", BindingFlags.GetProperty, null, messages, null);                            
                            if (objItem != null)
                            {
            
                                lines[0] = ("*** First message in Microsoft Outlook inbox (CDO) ***");
                                lines[1] = "";
                                sender = objItem.GetType().InvokeMember("Sender", BindingFlags.GetProperty, null, objItem, null);
                                lines[2] = "From: "+Convert.ToString(sender.GetType().InvokeMember("Name", BindingFlags.GetProperty, null, sender, null));
                                lines[3] = "Subject: "+Convert.ToString(objItem.GetType().InvokeMember("Subject", BindingFlags.GetProperty, null, objItem, null));
                            }
                        }
                        catch(Exception err)
                        {
                            StrToLog(err.Message);
                        }
                    
                    }
                }
                finally
                {            
                    securityManager1.DisableCDOWarnings = false;
                    if (sender != null)
                        Marshal.ReleaseComObject(sender);
                    if (objItem != null)
                        Marshal.ReleaseComObject(objItem);
                    if (messages != null)
                        Marshal.ReleaseComObject(messages);
                    if (inbox != null)
                        Marshal.ReleaseComObject(inbox);
                    if (mapiSession != null)
                        Marshal.ReleaseComObject(mapiSession);
                }
            }
            return lines;
        }


        private void timer1_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
           string[] firstMailCDO = DoCDO();           
           StrToLog(firstMailCDO[0]+" "+firstMailCDO[1]+" "+firstMailCDO[2]+" "+firstMailCDO[3]);
        }
    }
}
